package com.dayou.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dayou.dao.DocumentMapper;
import com.dayou.dto.DocumentDTO;
import com.dayou.entity.Document;
import com.dayou.entity.DocumentQuestion;
import com.dayou.service.IDocumentQuestionService;
import com.dayou.service.IDocumentService;
import com.dayou.vo.DocumentCycleVO;
import com.dayou.vo.DocumentVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.stream.Collectors;

/**
 * 类说明：
 *
 * @author: wucl
 * @since: 2023/7/13
 * created with IntelliJ IDEA.
 */
@Service
public class DocumentServiceImpl extends ServiceImpl<DocumentMapper, Document> implements IDocumentService {

    @Autowired
    private DocumentMapper documentMapper;

    @Autowired
    private IDocumentQuestionService documentQuestionService;
    @Override
    public DocumentCycleVO getDocumentCycleVO() {
        DocumentCycleVO documentCycleVO = documentMapper.getDocumentCycleVO();
        return documentCycleVO;
    }

    @Override
    public IPage<DocumentVO> getPage(DocumentVO documentVO, Page page) {
        IPage<DocumentVO> xPage = documentMapper.getPage(page,documentVO);
        return xPage;
    }

    @Transactional
    @Override
    public Boolean saveDocument(DocumentDTO documentDTO) {
        Document document = BeanUtil.copyProperties(documentDTO, Document.class);
        this.save(document);
        List<Long> questions = documentDTO.getQuestions();
        Long documentId = document.getId();
        List<DocumentQuestion> collect = questions.stream().map(x -> {
            DocumentQuestion dq = new DocumentQuestion();
            dq.setDocumentId(documentId);
            dq.setQuestionId(x);
            return dq;
        }).collect(Collectors.toList());
        return documentQuestionService.saveBatch(collect);
    }
}
